"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SoTerm(ProtocolElement):
    """
    A Sequence Ontology term identifier by its id and name (e.g.: id =
    SO:0001816 ; name = non synonymous)
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "name",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "org.gel.models.report.avro.SoTerm": reports_4_0_0.SoTerm,
        }

    __slots__ = [
        "id",
        "name",
    ]

    def __init__(
        self,
        id,
        name,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_0_0.SoTerm model.

        :param id:
            The SO term identifier (e.g.: SO:0001816)
        :type id: str
        :param name:
            The SO term name (e.g.: non synonymous)
        :type name: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.0.0"
